
/****************************************************************************/
/*      VTMK v1.11 for Microsoft Windows 9x. ELCUS, 1998,2002.              */
/*      Interface to driver VTMK.VXD v1.10 for Windows 95.                  */
/****************************************************************************/

#ifndef _VTMKX_
#define _VTMKX_

#define VTMK_DATA unsigned short

#define VTMK_VERSION_MIN 0x0105 /* v1.05 */
#define VTMK_VERSION 0x010B     /* v1.11 */

#define MAX_TMK_NUMBER 3

#define MAX_TMK_TYPE 5

#define RTMK 0
#define RTMK1 1
#define TMK400 2
#define TMKMPC 3
#define RTMK400 4
#define TMKX 5

#define ALL_TMKS 0x00FF

#define DATA_BC_RT 0x00
#define DATA_BC_RT_BRCST 0x08
#define DATA_RT_BC 0x01
#define DATA_RT_RT 0x02
#define DATA_RT_RT_BRCST 0x0A
#define CTRL_C_A 0x03
#define CTRL_C_BRCST 0x0B
#define CTRL_CD_A 0x04
#define CTRL_CD_BRCST 0x0C
#define CTRL_C_AD 0x05

#define BUS_A 0
#define BUS_B 1
#define BUS_1 0
#define BUS_2 1

#define S_ERAO_MASK 0x01
#define S_MEO_MASK 0x02
#define S_IB_MASK 0x04
#define S_TO_MASK 0x08
#define S_EM_MASK 0x10
#define S_EBC_MASK 0x20
#define S_DI_MASK 0x40
#define S_ELN_MASK 0x80
#define S_G1_MASK 0x8000
#define S_G2_MASK 0x4000

#define NWORDS_MASK 0x001F
#define CMD_MASK 0x001F
#define SUBADDR_MASK 0x03E0
#define CI_MASK 0x03E0
#define HBIT_MASK 0x0200
#define RT_DIR_MASK 0x0400
#define ADDRESS_MASK 0xF800
#define RTFL_MASK 0x0001
#define DNBA_MASK 0x0002
#define SSFL_MASK 0x0004
#define BUSY_MASK 0x0008
#define BRCST_MASK 0x0010
#define NULL_MASK 0x00E0
#define SREQ_MASK 0x0100
#define ERROR_MASK 0x0400

#define SREQ 0x01
#define BUSY 0x02
#define SSFL 0x04
#define RTFL 0x08
#define DNBA 0x10

#define CWB0 0x20
#define CWB1 0x40

#define BC_MODE 0x00
#define RT_MODE 0x80
#define MT_MODE 0x100
#define UNDEFINED_MODE 0xFFFF

#define RT_TRANSMIT 0x0400
#define RT_RECEIVE 0x0000

#define RT_ERROR_MASK 0x4000

#define RT_FLAG 0x8000
#define RT_FLAG_MASK 0x8000

#define RT_HBIT_MODE 0x0001
#define RT_FLAG_MODE 0x0002
#define RT_BRCST_MODE 0x0004
#define RT_DATA_BL 0x2000
#define RT_GENER1_BL 0x0004
#define RT_GENER2_BL 0x4000
#define BC_GENER1_BL 0x0004
#define BC_GENER2_BL 0x4000
#define MT_GENER1_BL 0x0004
#define MT_GENER2_BL 0x4000
#define TMK_IRQ_OFF 0x8000

#define CX_CC_MASK 0x000F
#define CX_CONT_MASK 0x0010
#define CX_BUS_MASK 0x0020
#define CX_SIG_MASK 0x8000
#define CX_INT_MASK 0x0020

#define CX_CONT 0x0010
#define CX_STOP 0x0000
#define CX_BUS_0 0x0000
#define CX_BUS_A 0x0000
#define CX_BUS_1 0x0020
#define CX_BUS_B 0x0020
#define CX_NOSIG 0x0000
#define CX_SIG 0x8000
#define CX_INT 0x0000
#define CX_NOINT 0x0020

#define SX_NOERR 0
#define SX_MEO 1
#define SX_TOA 2
#define SX_TOD 3
#define SX_ELN 4
#define SX_ERAO 5
#define SX_ESYN 6
#define SX_EBC 7

#define SX_ERR_MASK 0x0007
#define SX_IB_MASK 0x0008
#define SX_G1_MASK 0x0010
#define SX_G2_MASK 0x0020
#define SX_K2_MASK 0x0100
#define SX_K1_MASK 0x0200
#define SX_SCC_MASK 0x3C00
#define SX_ME_MASK 0x4000
#define SX_BUS_MASK 0x8000

#define SX_BUS_0 0x0000
#define SX_BUS_A 0x0000
#define SX_BUS_1 0x8000
#define SX_BUS_B 0x8000

#define GET_IO_DELAY 0xFFFF

#define CW(ADDR,DIR,SUBADDR,NWORDS) (((ADDR)<<11)|(DIR)|((SUBADDR)<<5)|((NWORDS)&0x1F))
#define CWM(ADDR,COMMAND) (((ADDR)<<11)|(CI_MASK)|(COMMAND))

/*#define CMD_ILLEGAL 0x000*/
#define CMD_DYNAMIC_BUS_CONTROL 0x400
#define CMD_SYNCHRONIZE 0x401
#define CMD_TRANSMIT_STATUS_WORD 0x402
#define CMD_INITIATE_SELF_TEST 0x403
#define CMD_TRANSMITTER_SHUTDOWN 0x404
#define CMD_OVERRIDE_TRANSMITTER_SHUTDOWN 0x405
#define CMD_INHIBIT_TERMINAL_FLAG_BIT 0x406
#define CMD_OVERRIDE_INHIBIT_TERMINAL_FLAG_BIT 0x407
#define CMD_RESET_REMOTE_TERMINAL 0x408
#define CMD_TRANSMIT_VECTOR_WORD 0x410
#define CMD_SYNCHRONIZE_WITH_DATA_WORD 0x011
#define CMD_TRANSMIT_LAST_COMMAND_WORD 0x412
#define CMD_TRANSMIT_BUILT_IN_TEST_WORD 0x413

#define TMK_BAD_TYPE 1
#define TMK_BAD_IRQ 2
#define TMK_BAD_NUMBER 3
#define BC_BAD_BUS 4
#define BC_BAD_BASE 5
#define BC_BAD_LEN 6
#define RT_BAD_PAGE 7
#define RT_BAD_LEN 8
#define RT_BAD_ADDRESS 9
#define RT_BAD_FUNC 10
#define BC_BAD_FUNC 11
#define TMK_BAD_FUNC 12
#define VTMK_BAD_VERSION 13

#define VTMK_tmkconfig 2
#define VTMK_tmkdone 3
#define VTMK_tmkgetmaxn 4
#define VTMK_tmkselect 5
#define VTMK_tmkselected 6
#define VTMK_tmkgetmode 7
#define VTMK_tmksetcwbits 8
#define VTMK_tmkclrcwbits 9
#define VTMK_tmkgetcwbits 10
#define VTMK_tmkdefevent 11
#define VTMK_tmkgetevd 12

#define VTMK_bcreset 13
#define VTMK_bc_def_tldw 14
#define VTMK_bc_enable_di 15
#define VTMK_bc_disable_di 16
#define VTMK_bcdefirqmode 17
#define VTMK_bcgetirqmode 18
#define VTMK_bcgetmaxbase 19
#define VTMK_bcdefbase 20
#define VTMK_bcgetbase 21
#define VTMK_bcputw 22
#define VTMK_bcgetw 23
#define VTMK_bcgetansw 24
#define VTMK_bcputblk 25
#define VTMK_bcgetblk 26
#define VTMK_bcdefbus 27
#define VTMK_bcgetbus 28
#define VTMK_bcstart 29
#define VTMK_bcstartx 30
#define VTMK_bcdeflink 31
#define VTMK_bcgetlink 32
#define VTMK_bcstop 33
#define VTMK_bcgetstate 34

#define VTMK_rtreset 35
#define VTMK_rtdefirqmode 36
#define VTMK_rtgetirqmode 37
#define VTMK_rtdefmode 38
#define VTMK_rtgetmode 39
#define VTMK_rtgetmaxpage 40
#define VTMK_rtdefpage 41
#define VTMK_rtgetpage 42
#define VTMK_rtdefpagepc 43
#define VTMK_rtdefpagebus 44
#define VTMK_rtgetpagepc 45
#define VTMK_rtgetpagebus 46
#define VTMK_rtdefaddress 47
#define VTMK_rtgetaddress 48
#define VTMK_rtdefsubaddr 49
#define VTMK_rtgetsubaddr 50
#define VTMK_rtputw 51
#define VTMK_rtgetw 52
#define VTMK_rtputblk 53
#define VTMK_rtgetblk 54
#define VTMK_rtsetanswbits 55
#define VTMK_rtclranswbits 56
#define VTMK_rtgetanswbits 57
#define VTMK_rtgetflags 58
#define VTMK_rtputflags 59
#define VTMK_rtsetflag 60
#define VTMK_rtclrflag 61
#define VTMK_rtgetflag 62
#define VTMK_rtgetstate 63
#define VTMK_rtbusy 64
#define VTMK_rtlock 65
#define VTMK_rtunlock 66
#define VTMK_rtgetcmddata 67
#define VTMK_rtputcmddata 68

#define VTMK_mtreset 69
#define VTMK_mtdefirqmode 70
#define VTMK_mtgetirqmode 71
#define VTMK_mtgetmaxbase 72
#define VTMK_mtdefbase 73
#define VTMK_mtgetbase 74
#define VTMK_mtputw 75
#define VTMK_mtgetw 76
#define VTMK_mtgetsw 77
#define VTMK_mtputblk 78
#define VTMK_mtgetblk 79
#define VTMK_mtstartx 80
#define VTMK_mtdeflink 81
#define VTMK_mtgetlink 82
#define VTMK_mtstop 83
#define VTMK_mtgetstate 84

#define VTMK_tmkgetinfo 85
#define VTMK_GetVersion 86

typedef DWORD (WINAPI *_VTMK4HiddenKernel32Proc)(HANDLE);
HINSTANCE _hinstVTMK4Kernel32;
_VTMK4HiddenKernel32Proc _VTMK4OpenVxDHandle;

typedef struct
{
 short nType;
 char szName[10];
 unsigned short wPorts1;
 unsigned short wPorts2;
 unsigned short wIrq1;
 unsigned short wIrq2;
 unsigned short wIODelay;
} TTmkConfigData;

typedef struct
{
  int nInt;
  unsigned short wMode;
  union
  {
    struct
    {
      unsigned short wResult;
      unsigned short wAW1;
      unsigned short wAW2;
    } bc;
    struct
    {
      unsigned short wBase;
      unsigned short wResultX;
    } bcx;
    struct
    {
      unsigned short wStatus;
      unsigned short wCmd;
    } rt;
    struct
    {
      unsigned short wBase;
      unsigned short wResultX;
    } mt;
  };
} TTmkEventData;

int tmkError;

int _VTMK4tmkNumber;
HANDLE _ahVTMK4Event[MAX_TMK_NUMBER+1];
HANDLE _hVTMK4VxD = 0;

/*****************Definitions***************************/

int tmkgetmaxn();
int tmkconfig( int tmkNumber );
int tmkdone( int tmkNumber );
int tmkselect( int tmkNumber );
int tmkselected();
VTMK_DATA tmkgetmode();
void tmksetcwbits( VTMK_DATA tmkSetControl );
void tmkclrcwbits( VTMK_DATA tmkClrControl );
VTMK_DATA tmkgetcwbits();

/*
void bcdefintnorm( void (* UserNormBC)( VTMK_DATA, VTMK_DATA, VTMK_DATA ) );
void bcdefintexc( void (* UserExcBC)( VTMK_DATA, VTMK_DATA, VTMK_DATA ) );
void bcdefintx( void (* UserXBC)( VTMK_DATA, VTMK_DATA ) );
void bcdefintsig( void (* UserSigBC)( VTMK_DATA ) );
*/
int bcreset();
void bc_def_tldw( VTMK_DATA wTLDW );
void bc_enable_di();
void bc_disable_di();
int bcdefirqmode( VTMK_DATA bcIrqMode );
VTMK_DATA bcgetirqmode();
VTMK_DATA bcgetmaxbase();
int bcdefbase( VTMK_DATA bcBasePC );
VTMK_DATA bcgetbase();
void bcputw( VTMK_DATA bcAddr, VTMK_DATA bcData );
VTMK_DATA bcgetw( VTMK_DATA bcAddr );
DWORD bcgetansw( VTMK_DATA bcCtrlCode );
void bcputblk( VTMK_DATA bcAddr, void *pcBuffer, VTMK_DATA cwLength );
void bcgetblk( VTMK_DATA bcAddr, void *pcBuffer, VTMK_DATA cwLength );
int bcdefbus( VTMK_DATA bcBus );
VTMK_DATA bcgetbus();
int bcstart( VTMK_DATA bcBase, VTMK_DATA bcCtrlCode );
int bcstartx( VTMK_DATA bcBase, VTMK_DATA bcCtrlCode );
int bcdeflink( VTMK_DATA bcBase, VTMK_DATA bcCtrlCode );
DWORD bcgetlink();
VTMK_DATA bcstop();
DWORD bcgetstate();

/*
void rtdefintcmd( void (* UserCmdRT)( VTMK_DATA ) );
void rtdefinterr( void (* UserErrRT)( VTMK_DATA ) );
void rtdefintdata( void (* UserDataRT)( VTMK_DATA ) );
*/
int rtreset();
int rtdefirqmode( VTMK_DATA rtIrqMode );
VTMK_DATA rtgetirqmode();
int rtdefmode( VTMK_DATA rtMode );
VTMK_DATA rtgetmode();
VTMK_DATA rtgetmaxpage();
int rtdefpage( VTMK_DATA rtPage );
VTMK_DATA rtgetpage();
int rtdefpagepc( VTMK_DATA rtPagePC );
int rtdefpagebus( VTMK_DATA rtPageBus );
VTMK_DATA rtgetpagepc();
VTMK_DATA rtgetpagebus();
int rtdefaddress( VTMK_DATA rtAddress );
VTMK_DATA rtgetaddress();
void rtdefsubaddr( VTMK_DATA rtDir, VTMK_DATA rtSubAddr);
VTMK_DATA rtgetsubaddr();
void rtputw( VTMK_DATA rtAddr, VTMK_DATA rtData );
VTMK_DATA rtgetw( VTMK_DATA rtAddr );
void rtputblk( VTMK_DATA rtAddr, void *pcBuffer, VTMK_DATA cwLength );
void rtgetblk( VTMK_DATA rtAddr, void *pcBuffer, VTMK_DATA cwLength );
void rtsetanswbits( VTMK_DATA rtSetControl );
void rtclranswbits( VTMK_DATA rtClrControl );
VTMK_DATA rtgetanswbits();
void rtgetflags( void *pcBuffer, VTMK_DATA rtDir, VTMK_DATA rtFlagMin, VTMK_DATA rtFlagMax );
void rtputflags( void *pcBuffer, VTMK_DATA rtDir, VTMK_DATA rtFlagMin, VTMK_DATA rtFlagMax );
void rtsetflag();
void rtclrflag();
VTMK_DATA rtgetflag( VTMK_DATA rtDir, VTMK_DATA rtSubAddr );
VTMK_DATA rtgetstate();
VTMK_DATA rtbusy();
void rtlock( VTMK_DATA rtDir, VTMK_DATA rtSubAddr );
void rtunlock();
VTMK_DATA rtgetcmddata( VTMK_DATA rtBusCommand );
void rtputcmddata( VTMK_DATA rtBusCommand, VTMK_DATA rtData );

/*
void mtdefintx( void (* UserIntXMT)( VTMK_DATA, VTMK_DATA ) );
void mtdefintsig( void (* UserSigMT)( VTMK_DATA ) );
*/
int mtreset();
#define mtdefirqmode bcdefirqmode
#define mtgetirqmode bcgetirqmode
#define mtgetmaxbase bcgetmaxbase
#define mtdefbase bcdefbase
#define mtgetbase bcgetbase
#define mtputw bcputw
#define mtgetw bcgetw
VTMK_DATA mtgetsw();
#define mtputblk bcputblk
#define mtgetblk bcgetblk
#define mtstartx bcstartx
#define mtdeflink bcdeflink
#define mtgetlink bcgetlink
#define mtstop bcstop
#define mtgetstate bcgetstate


/*****************Functions***************************/

DWORD TmkOpen()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DWORD dwErrorCode;
  int iTMK;
  _hVTMK4VxD = CreateFile("\\\\.\\VTMK.VXD", 0,0,0, TRUNCATE_EXISTING, FILE_FLAG_DELETE_ON_CLOSE, 0);
  if ( _hVTMK4VxD == INVALID_HANDLE_VALUE )
  {
    dwErrorCode = GetLastError();
/*
    if ( dwErrorCode == ERROR_NOT_SUPPORTED )
    {
      MessageBox(NULL,"Unable to open VxD,\ndevice does not support DeviceIOCTL",szTitle,MB_OK|MB_ICONSTOP);
    }
    else
    {
      sprintf(szPrintf,"Unable to open VxD, Error code: %lx", dwErrorCode);
      MessageBox(NULL,szPrintf,szTitle,MB_OK|MB_ICONSTOP);
    }
*/
    _hVTMK4VxD = 0;
    return dwErrorCode;
  }
  for (iTMK = 0; iTMK <= MAX_TMK_NUMBER; ++iTMK)
    _ahVTMK4Event[iTMK] = 0;
  if (!DeviceIoControl(_hVTMK4VxD, VTMK_GetVersion, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL) ||
      _awVTMK4OutBuf[0] < VTMK_VERSION_MIN)
  {
    CloseHandle(_hVTMK4VxD);
    _hVTMK4VxD = 0;
    return VTMK_BAD_VERSION;
  }
  _hinstVTMK4Kernel32 = GetModuleHandle("kernel32.dll");
  if (_hinstVTMK4Kernel32 == NULL)
  {
    CloseHandle(_hVTMK4VxD);
    _hVTMK4VxD = 0;
    return TMK_BAD_FUNC;
  }
  _VTMK4OpenVxDHandle = (_VTMK4HiddenKernel32Proc)GetProcAddress(_hinstVTMK4Kernel32, "OpenVxDHandle");
  return 0;
}

void TmkClose()
{
  if (_hVTMK4VxD)
  {
    CloseHandle(_hVTMK4VxD);
    _hVTMK4VxD = 0;
  }
}

int tmkgetmaxn()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[2];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkgetmaxn, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return ((int)(_awVTMK4OutBuf[0]));
}
int tmkconfig( int tmkNumber )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _VTMK4tmkNumber = tmkNumber;
  _awVTMK4InBuf[0]=(WORD)tmkNumber;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_tmkconfig, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
int tmkdone( int tmkNumber )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  int iTMK;
  if (tmkNumber == ALL_TMKS)
  {
    for (iTMK = 0; iTMK <= MAX_TMK_NUMBER; ++iTMK)
      _ahVTMK4Event[iTMK] = 0;
  }
  else if (tmkNumber >= 0 && tmkNumber <= MAX_TMK_NUMBER)
    _ahVTMK4Event[tmkNumber] = 0;
  _awVTMK4InBuf[0]=(WORD)tmkNumber;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_tmkdone, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
int tmkselect( int tmkNumber )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _VTMK4tmkNumber = tmkNumber;
  _awVTMK4InBuf[0]=(WORD)tmkNumber;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_tmkselect, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
int tmkselected()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkselected, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return (_VTMK4tmkNumber = (int)(_awVTMK4OutBuf[0]));
}
VTMK_DATA tmkgetmode()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkgetmode, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
void tmksetcwbits( VTMK_DATA tmkSetControl )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=tmkSetControl;
  DeviceIoControl(_hVTMK4VxD, VTMK_tmksetcwbits, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void tmkclrcwbits( VTMK_DATA tmkClrControl )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=tmkClrControl;
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkclrcwbits, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
VTMK_DATA tmkgetcwbits()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkgetcwbits, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
void tmkdefevent( HANDLE hEvent, BOOL fEventSet )
{
  WORD _awVTMK4InBuf[4], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DWORD hVxDEvent;
  int iTMK;
  if (hEvent != 0)
  {
    for (iTMK = 0; iTMK <= MAX_TMK_NUMBER; ++iTMK)
    {
      if (hEvent == _ahVTMK4Event[iTMK])
        break;
    }
    if (iTMK > MAX_TMK_NUMBER)
    {
      hVxDEvent = (_VTMK4OpenVxDHandle)(hEvent);
      _ahVTMK4Event[_VTMK4tmkNumber] = hEvent;
    }
  }
  else
  {
    hVxDEvent = 0;
    _ahVTMK4Event[_VTMK4tmkNumber] = 0;
  }
  _awVTMK4InBuf[0]=LOWORD(hVxDEvent);
  _awVTMK4InBuf[1]=HIWORD(hVxDEvent);
  _awVTMK4InBuf[2]=LOWORD(fEventSet);
  _awVTMK4InBuf[3]=HIWORD(fEventSet);
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkdefevent, _awVTMK4InBuf, 8, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void tmkgetevd( TTmkEventData *pEvD )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[6];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkgetevd, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 12, &_cbVTMK4Ret, NULL);
  pEvD->nInt = ((DWORD*)(_awVTMK4OutBuf))[0];
  switch (pEvD->wMode = _awVTMK4OutBuf[2])
  {
  case BC_MODE:
    switch (pEvD->nInt)
    {
    case 1:
      pEvD->bc.wResult = _awVTMK4OutBuf[3];
      break;
    case 2:
      pEvD->bc.wResult = _awVTMK4OutBuf[3];
      pEvD->bc.wAW1 = _awVTMK4OutBuf[4];
      pEvD->bc.wAW2 = _awVTMK4OutBuf[5];
      break;
    case 3:
      pEvD->bcx.wResultX = _awVTMK4OutBuf[3];
      pEvD->bcx.wBase = _awVTMK4OutBuf[4];
      break;
    case 4:
      pEvD->bcx.wBase = _awVTMK4OutBuf[3];
      break;
    }
    break;
  case MT_MODE:
    switch (pEvD->nInt)
    {
    case 3:
      pEvD->mt.wResultX = _awVTMK4OutBuf[3];
      pEvD->mt.wBase = _awVTMK4OutBuf[4];
      break;
    case 4:
      pEvD->mt.wBase = _awVTMK4OutBuf[3];
      break;
    }
    break;
  case RT_MODE:
    switch (pEvD->nInt)
    {
    case 1:
      pEvD->rt.wCmd = _awVTMK4OutBuf[3];
      break;
    case 2:
    case 3:
      pEvD->rt.wStatus = _awVTMK4OutBuf[3];
      break;
    }
    break;
  }
}
void tmkgetinfo(TTmkConfigData *pConfD)
{
  WORD _awVTMK4InBuf[2], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=LOWORD(pConfD);
  _awVTMK4InBuf[1]=HIWORD(pConfD);
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkgetinfo, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}

/*
void bcdefintnorm( void (* UserNormBC)( VTMK_DATA, VTMK_DATA, VTMK_DATA ) )
{
  ;
//  DeviceIoControl(_hVTMK4VxD, VTMK_bcdefintnorm, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void bcdefintexc( void (* UserExcBC)( VTMK_DATA, VTMK_DATA, VTMK_DATA ) )
{
  ;
//  DeviceIoControl(_hVTMK4VxD, VTMK_bcdefintexc, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void bcdefintx( void (* UserXBC)( VTMK_DATA, VTMK_DATA ) )
{
  ;
//  DeviceIoControl(_hVTMK4VxD, VTMK_bcdefintx, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void bcdefintsig( void (* UserSigBC)( VTMK_DATA ) )
{
  ;
//  DeviceIoControl(_hVTMK4VxD, VTMK_bcdefintsig, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
*/
int bcreset()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_bcreset, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
void bc_def_tldw( VTMK_DATA wTLDW )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=wTLDW;
  DeviceIoControl(_hVTMK4VxD, VTMK_bc_def_tldw, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void bc_enable_di()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_bc_enable_di, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void bc_disable_di()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_bc_disable_di, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
int bcdefirqmode( VTMK_DATA bcIrqMode )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=bcIrqMode;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_bcdefirqmode, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
VTMK_DATA bcgetirqmode()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetirqmode, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
VTMK_DATA bcgetmaxbase()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetmaxbase, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
int bcdefbase( VTMK_DATA bcBasePC )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=bcBasePC;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_bcdefbase, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
VTMK_DATA bcgetbase()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetbase, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
void bcputw( VTMK_DATA bcAddr, VTMK_DATA bcData )
{
  WORD _awVTMK4InBuf[2], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=bcAddr;
  _awVTMK4InBuf[1]=bcData;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcputw, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
VTMK_DATA bcgetw( VTMK_DATA bcAddr )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=bcAddr;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetw, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
DWORD bcgetansw( VTMK_DATA bcCtrlCode )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=bcCtrlCode;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetansw, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 4, &_cbVTMK4Ret, NULL);
  return (((DWORD*)(_awVTMK4OutBuf))[0]);
}
void bcputblk( VTMK_DATA bcAddr, void *pcBuffer, VTMK_DATA cwLength )
{
  WORD _awVTMK4InBuf[4], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=bcAddr;
  _awVTMK4InBuf[1]=(WORD)(LOWORD(pcBuffer));
  _awVTMK4InBuf[2]=(WORD)(HIWORD(pcBuffer));
  _awVTMK4InBuf[3]=cwLength;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcputblk, _awVTMK4InBuf, 8, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void bcgetblk( VTMK_DATA bcAddr, void *pcBuffer, VTMK_DATA cwLength )
{
  WORD _awVTMK4InBuf[4], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=bcAddr;
  _awVTMK4InBuf[1]=(WORD)(LOWORD(pcBuffer));
  _awVTMK4InBuf[2]=(WORD)(HIWORD(pcBuffer));
  _awVTMK4InBuf[3]=cwLength;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetblk, _awVTMK4InBuf, 8, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
int bcdefbus( VTMK_DATA bcBus )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=bcBus;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_bcdefbus, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
VTMK_DATA bcgetbus()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetbus, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
int bcstart( VTMK_DATA bcBase, VTMK_DATA bcCtrlCode )
{
  WORD _awVTMK4InBuf[2], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=bcBase;
  _awVTMK4InBuf[1]=bcCtrlCode;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_bcstart, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
int bcstartx( VTMK_DATA bcBase, VTMK_DATA bcCtrlCode )
{
  WORD _awVTMK4InBuf[2], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=bcBase;
  _awVTMK4InBuf[1]=bcCtrlCode;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_bcstartx, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
int bcdeflink( VTMK_DATA bcBase, VTMK_DATA bcCtrlCode )
{
  WORD _awVTMK4InBuf[2], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=bcBase;
  _awVTMK4InBuf[1]=bcCtrlCode;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_bcdeflink, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
DWORD bcgetlink()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[2];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetlink, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 4, &_cbVTMK4Ret, NULL);
  return (((DWORD*)(_awVTMK4OutBuf))[0]);
}
VTMK_DATA bcstop()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcstop, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
DWORD bcgetstate()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[2];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetstate, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 4, &_cbVTMK4Ret, NULL);
  return (((DWORD*)(_awVTMK4OutBuf))[0]);
}

/*
void rtdefintcmd( void (* UserCmdRT)( VTMK_DATA ) )
{
  ;
//  DeviceIoControl(_hVTMK4VxD, VTMK_rtdefintcmd, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void rtdefinterr( void (* UserErrRT)( VTMK_DATA ) )
{
  ;
//  DeviceIoControl(_hVTMK4VxD, VTMK_rtdefinterr, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void rtdefintdata( void (* UserDataRT)( VTMK_DATA ) )
{
  ;
//  DeviceIoControl(_hVTMK4VxD, VTMK_rtdefintdata, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
*/
int rtreset()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_rtreset, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
int rtdefirqmode( VTMK_DATA rtIrqMode )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtIrqMode;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_rtdefirqmode, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
VTMK_DATA rtgetirqmode()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetirqmode, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
int rtdefmode( VTMK_DATA rtMode )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtMode;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_rtdefmode, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
VTMK_DATA rtgetmode()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetmode, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
VTMK_DATA rtgetmaxpage()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetmaxpage, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
int rtdefpage( VTMK_DATA rtPage )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtPage;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_rtdefpage, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
VTMK_DATA rtgetpage()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetpage, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
int rtdefpagepc( VTMK_DATA rtPagePC )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtPagePC;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_rtdefpagepc, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
int rtdefpagebus( VTMK_DATA rtPageBus )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtPageBus;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_rtdefpagebus, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
VTMK_DATA rtgetpagepc()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetpagepc, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
VTMK_DATA rtgetpagebus()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetpagebus, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
int rtdefaddress( VTMK_DATA rtAddress )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtAddress;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_rtdefaddress, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
VTMK_DATA rtgetaddress()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetaddress, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
void rtdefsubaddr( VTMK_DATA rtDir, VTMK_DATA rtSubAddr)
{
  WORD _awVTMK4InBuf[2], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtDir;
  _awVTMK4InBuf[1]=rtSubAddr;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtdefsubaddr, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
VTMK_DATA rtgetsubaddr()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetsubaddr, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
void rtputw( VTMK_DATA rtAddr, VTMK_DATA rtData )
{
  WORD _awVTMK4InBuf[2], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtAddr;
  _awVTMK4InBuf[1]=rtData;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtputw, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
VTMK_DATA rtgetw( VTMK_DATA rtAddr )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtAddr;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetw, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
void rtputblk( VTMK_DATA rtAddr, void *pcBuffer, VTMK_DATA cwLength )
{
  WORD _awVTMK4InBuf[4], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtAddr;
  _awVTMK4InBuf[1]=(WORD)(LOWORD(pcBuffer));
  _awVTMK4InBuf[2]=(WORD)(HIWORD(pcBuffer));
  _awVTMK4InBuf[3]=cwLength;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtputblk, _awVTMK4InBuf, 8, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void rtgetblk( VTMK_DATA rtAddr, void *pcBuffer, VTMK_DATA cwLength )
{
  WORD _awVTMK4InBuf[4], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtAddr;
  _awVTMK4InBuf[1]=(WORD)(LOWORD(pcBuffer));
  _awVTMK4InBuf[2]=(WORD)(HIWORD(pcBuffer));
  _awVTMK4InBuf[3]=cwLength;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetblk, _awVTMK4InBuf, 8, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void rtsetanswbits( VTMK_DATA rtSetControl )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtSetControl;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtsetanswbits, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void rtclranswbits( VTMK_DATA rtClrControl )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtClrControl;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtclranswbits, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
VTMK_DATA rtgetanswbits()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetanswbits, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
void rtgetflags( void *pcBuffer, VTMK_DATA rtDir, VTMK_DATA rtFlagMin, VTMK_DATA rtFlagMax )
{
  WORD _awVTMK4InBuf[5], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=(WORD)(LOWORD(pcBuffer));
  _awVTMK4InBuf[1]=(WORD)(HIWORD(pcBuffer));
  _awVTMK4InBuf[2]=rtDir;
  _awVTMK4InBuf[3]=rtFlagMin;
  _awVTMK4InBuf[4]=rtFlagMax;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetflags, _awVTMK4InBuf, 10, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void rtputflags( void *pcBuffer, VTMK_DATA rtDir, VTMK_DATA rtFlagMin, VTMK_DATA rtFlagMax )
{
  WORD _awVTMK4InBuf[5], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=(WORD)(LOWORD(pcBuffer));
  _awVTMK4InBuf[1]=(WORD)(HIWORD(pcBuffer));
  _awVTMK4InBuf[2]=rtDir;
  _awVTMK4InBuf[3]=rtFlagMin;
  _awVTMK4InBuf[4]=rtFlagMax;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtputflags, _awVTMK4InBuf, 10, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void rtsetflag()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtsetflag, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void rtclrflag()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtclrflag, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
VTMK_DATA rtgetflag( VTMK_DATA rtDir, VTMK_DATA rtSubAddr )
{
  WORD _awVTMK4InBuf[2], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtDir;
  _awVTMK4InBuf[1]=rtSubAddr;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetflag, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
VTMK_DATA rtgetstate()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetstate, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
VTMK_DATA rtbusy()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtbusy, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
void rtlock( VTMK_DATA rtDir, VTMK_DATA rtSubAddr )
{
  WORD _awVTMK4InBuf[2], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtDir;
  _awVTMK4InBuf[1]=rtSubAddr;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtlock, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void rtunlock()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtunlock, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
VTMK_DATA rtgetcmddata( VTMK_DATA rtBusCommand )
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtBusCommand;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetcmddata, _awVTMK4InBuf, 2, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}
void rtputcmddata( VTMK_DATA rtBusCommand, VTMK_DATA rtData )
{
  WORD _awVTMK4InBuf[2], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  _awVTMK4InBuf[0]=rtBusCommand;
  _awVTMK4InBuf[1]=rtData;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtputcmddata, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}

/*
void mtdefintx( void (* UserIntXMT)( VTMK_DATA, VTMK_DATA ) )
{
  ;
//  DeviceIoControl(_hVTMK4VxD, VTMK_mtdefintx, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
void mtdefintsig( void (* UserSigMT)( VTMK_DATA ) )
{
  ;
//  DeviceIoControl(_hVTMK4VxD, VTMK_mtdefintsig, _awVTMK4InBuf, 4, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL);
}
*/
int mtreset()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  return (DeviceIoControl(_hVTMK4VxD, VTMK_mtreset, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 0, &_cbVTMK4Ret, NULL))?0:GetLastError();
}
VTMK_DATA mtgetsw()
{
  WORD _awVTMK4InBuf[1], _awVTMK4OutBuf[1];
  DWORD _cbVTMK4Ret;
  DeviceIoControl(_hVTMK4VxD, VTMK_mtgetsw, _awVTMK4InBuf, 0, _awVTMK4OutBuf, 2, &_cbVTMK4Ret, NULL);
  return _awVTMK4OutBuf[0];
}

#endif
