{
****************************************************************************
*      VTMK v1.11 for Microsoft Windows 9x. ELCUS, 1998,2002.              *
*      Translated for Borland Delphi 3 by Gremlins Group, 1999.            *
*      Interface to driver VTMK.VXD v1.10 for Windows 95.                  *
****************************************************************************
}
unit VTMK4;
interface
uses Windows;
type

 VTMK_DATA = word; {unsigned short}

const

 VTMK_VERSION_MIN = $0105; { v1.05 }
 VTMK_VERSION     = $010B; { v1.11 }

 MAX_TMK_NUMBER   = 3;

 MAX_TMK_TYPE     = 5;

 RTMK             = 0;
 RTMK1            = 1;
 TMK400           = 2;
 TMKMPC           = 3;
 RTMK400          = 4;
 TMKX             = 5;

 ALL_TMKS         = $00FF;

 DATA_BC_RT       = $00;
 DATA_BC_RT_BRCST = $08;
 DATA_RT_BC       = $01;
 DATA_RT_RT       = $02;
 DATA_RT_RT_BRCST = $0A;
 CTRL_C_A         = $03;
 CTRL_C_BRCST     = $0B;
 CTRL_CD_A        = $04;
 CTRL_CD_BRCST    = $0C;
 CTRL_C_AD        = $05;

 BUS_A            = 0;
 BUS_B            = 1;
 BUS_1            = 0;
 BUS_2            = 1;

 S_ERAO_MASK      = $01;
 S_MEO_MASK       = $02;
 S_IB_MASK        = $04;
 S_TO_MASK        = $08;
 S_EM_MASK        = $10;
 S_EBC_MASK       = $20;
 S_DI_MASK        = $40;
 S_ELN_MASK       = $80;
 S_G1_MASK        = $8000;
 S_G2_MASK        = $4000;

 NWORDS_MASK      = $001F;
 CMD_MASK         = $001F;
 SUBADDR_MASK     = $03E0;
 CI_MASK          = $03E0;
 HBIT_MASK        = $0200;
 RT_DIR_MASK      = $0400;
 ADDRESS_MASK     = $F800;
 RTFL_MASK        = $0001;
 DNBA_MASK        = $0002;
 SSFL_MASK        = $0004;
 BUSY_MASK        = $0008;
 BRCST_MASK       = $0010;
 NULL_MASK        = $00E0;
 SREQ_MASK        = $0100;
 ERROR_MASK       = $0400;

 SREQ             = $01;
 BUSY             = $02;
 SSFL             = $04;
 RTFL             = $08;
 DNBA             = $10;

 CWB0 = $20;
 CWB1 = $40;

 BC_MODE = $00;
 RT_MODE = $80;
 MT_MODE = $100;
 UNDEFINED_MODE = $FFFF;

 RT_TRANSMIT    = $0400;
 RT_RECEIVE     = $0000;

 RT_ERROR_MASK  = $4000;

 RT_FLAG        = $8000;
 RT_FLAG_MASK   = $8000;

  RT_HBIT_MODE = $0001;
  RT_FLAG_MODE = $0002;
  RT_BRCST_MODE = $0004;
  RT_DATA_BL = $2000;
  RT_GENER1_BL = $0004;
  RT_GENER2_BL = $4000;
  BC_GENER1_BL = $0004;
  BC_GENER2_BL = $4000;
  MT_GENER1_BL = $0004;
  MT_GENER2_BL = $4000;
  TMK_IRQ_OFF = $8000;

  CX_CC_MASK = $000F;
  CX_CONT_MASK = $0010;
  CX_BUS_MASK = $0020;
  CX_SIG_MASK = $8000;
  CX_INT_MASK = $0020;

  CX_CONT     = $0010;
  CX_STOP     = $0000;
  CX_BUS_0    = $0000;
  CX_BUS_A    = $0000;
  CX_BUS_1    = $0020;
  CX_BUS_B    = $0020;
  CX_NOSIG    = $0000;
  CX_SIG      = $8000;
  CX_INT      = $0000;
  CX_NOINT    = $0020;

  SX_NOERR    = 0;
  SX_MEO      = 1;
  SX_TOA      = 2;
  SX_TOD      = 3;
  SX_ELN      = 4;
  SX_ERAO     = 5;
  SX_ESYN     = 6;
  SX_EBC      = 7;

  SX_ERR_MASK = $0007;
  SX_IB_MASK  = $0008;
  SX_G1_MASK  = $0010;
  SX_G2_MASK  = $0020;
  SX_K2_MASK  = $0100;
  SX_K1_MASK  = $0200;
  SX_SCC_MASK = $3C00;
  SX_ME_MASK  = $4000;
  SX_BUS_MASK = $8000;

  SX_BUS_0 = $0000;
  SX_BUS_A = $0000;
  SX_BUS_1 = $8000;
  SX_BUS_B = $8000;

 GET_IO_DELAY = $FFFF;

 TMK_BAD_TYPE   =    1;
 TMK_BAD_IRQ    =    2;
 TMK_BAD_NUMBER =    3;
 BC_BAD_BUS     =    4;
 BC_BAD_BASE    =    5;
 BC_BAD_LEN     =    6;
 RT_BAD_PAGE    =    7;
 RT_BAD_LEN     =    8;
 RT_BAD_ADDRESS =    9;
 RT_BAD_FUNC    =    10;
 BC_BAD_FUNC    =    11;
 TMK_BAD_FUNC   =    12;
 VTMK_BAD_VERSION =  13;

 VTMK_tmkconfig   =  2;
 VTMK_tmkdone     =  3;
 VTMK_tmkgetmaxn  =  4;
 VTMK_tmkselect   =  5;
 VTMK_tmkselected =  6;
 VTMK_tmkgetmode  =  7;
 VTMK_tmksetcwbits = 8;
 VTMK_tmkclrcwbits = 9;
 VTMK_tmkgetcwbits = 10;
 VTMK_tmkdefevent  = 11;
 VTMK_tmkgetevd    = 12;

 VTMK_bcreset       = 13;
 VTMK_bc_def_tldw   = 14;
 VTMK_bc_enable_di  = 15;
 VTMK_bc_disable_di = 16;
 VTMK_bcdefirqmode  = 17;
 VTMK_bcgetirqmode  = 18;
 VTMK_bcgetmaxbase  = 19;
 VTMK_bcdefbase     = 20;
 VTMK_bcgetbase     = 21;
 VTMK_bcputw        = 22;
 VTMK_bcgetw        = 23;
 VTMK_bcgetansw     = 24;
 VTMK_bcputblk      = 25;
 VTMK_bcgetblk      = 26;
 VTMK_bcdefbus      = 27;
 VTMK_bcgetbus      = 28;
 VTMK_bcstart       = 29;
 VTMK_bcstartx      = 30;
 VTMK_bcdeflink     = 31;
 VTMK_bcgetlink     = 32;
 VTMK_bcstop        = 33;
 VTMK_bcgetstate    = 34;

 VTMK_rtreset       = 35;
 VTMK_rtdefirqmode  = 36;
 VTMK_rtgetirqmode  = 37;
 VTMK_rtdefmode     = 38;
 VTMK_rtgetmode     = 39;
 VTMK_rtgetmaxpage  = 40;
 VTMK_rtdefpage     = 41;
 VTMK_rtgetpage     = 42;
 VTMK_rtdefpagepc   = 43;
 VTMK_rtdefpagebus  = 44;
 VTMK_rtgetpagepc   = 45;
 VTMK_rtgetpagebus  = 46;
 VTMK_rtdefaddress  = 47;
 VTMK_rtgetaddress  = 48;
 VTMK_rtdefsubaddr  = 49;
 VTMK_rtgetsubaddr  = 50;
 VTMK_rtputw        = 51;
 VTMK_rtgetw        = 52;
 VTMK_rtputblk      = 53;
 VTMK_rtgetblk      = 54;
 VTMK_rtsetanswbits = 55;
 VTMK_rtclranswbits = 56;
 VTMK_rtgetanswbits = 57;
 VTMK_rtgetflags    = 58;
 VTMK_rtputflags    = 59;
 VTMK_rtsetflag     = 60;
 VTMK_rtclrflag     = 61;
 VTMK_rtgetflag     = 62;
 VTMK_rtgetstate    = 63;
 VTMK_rtbusy        = 64;
 VTMK_rtlock        = 65;
 VTMK_rtunlock      = 66;
 VTMK_rtgetcmddata  = 67;
 VTMK_rtputcmddata  = 68;

 VTMK_mtreset       = 69;
 VTMK_mtdefirqmode  = 70;
 VTMK_mtgetirqmode  = 71;
 VTMK_mtgetmaxbase  = 72;
 VTMK_mtdefbase     = 73;
 VTMK_mtgetbase     = 74;
 VTMK_mtputw        = 75;
 VTMK_mtgetw        = 76;
 VTMK_mtgetsw       = 77;
 VTMK_mtputblk      = 78;
 VTMK_mtgetblk      = 79;
 VTMK_mtstartx      = 80;
 VTMK_mtdeflink     = 81;
 VTMK_mtgetlink     = 82;
 VTMK_mtstop        = 83;
 VTMK_mtgetstate    = 84;

 VTMK_tmkgetinfo    = 85;
 VTMK_GetVersion    = 86;

type

 DWORD = LongInt;

 _VTMK4HiddenKernel32Proc = function(HANDLE:THandle):DWORD;far pascal;


 PTmkConfigData = ^TTmkConfigData;
 TTmkConfigData = packed record
                   nType: SmallInt;
                   szName: array[0..9] of byte;
                   wPorts1:word;
                   wPorts2:word;
                   wIrq1:  word;
                   wIrq2:  word;
                   wIODelay:word;
                  end;

 PTMKEventData = ^TTMKEventData;
 TTmkEventData =  packed record
                   nInt:  integer;
                   wMode: word;
                   case integer of
                    0:(
                         wResult:word;
                         wAW1:   word;
                         wAW2:   word;
                       );
                    1:(
                         wBase:  word;
                         wResultX: word;
                       );
                    2: (
                         wStatus:word;
                         wCmd:   word;
                       );
                  end;
var

 tmkError:integer;

 _VTMK4OpenVxDHandle:_VTMK4HiddenKernel32Proc;

 _VTMK4tmkNumber:integer;

 _ahVTMK4Event:array[0..MAX_TMK_NUMBER] of THandle;

 const
 _hVTMK4VxD:THandle = 0;

{*****************Definitions***************************}

function TmkOpen:DWORD;
procedure TmkClose;

procedure tmkdefevent(hEvent:tHandle;fEventSet:boolean);
procedure tmkgetevd( pEvD:PTmkEventData );
procedure tmkgetinfo(pConfD:PTmkConfigData);

function tmkgetmaxn:integer;
function tmkconfig(tmkNumber:integer):integer;
function tmkdone(tmkNumber:integer):integer;
function tmkselect(tmkNumber:integer):integer;
function tmkselected:integer;
function tmkgetmode:VTMK_DATA;
procedure tmksetcwbits( tmkSetControl : VTMK_DATA);
procedure tmkclrcwbits( tmkClrControl : VTMK_DATA);
function  tmkgetcwbits:VTMK_DATA;

function bcreset:integer;
procedure bc_def_tldw( wTLDW:VTMK_DATA );
procedure bc_enable_di;
procedure bc_disable_di;
function bcdefirqmode( bcIrqMode : VTMK_DATA):integer;
function bcgetirqmode:VTMK_DATA;
function bcgetmaxbase:VTMK_DATA;
function bcdefbase( bcBasePC : VTMK_DATA ):integer;
function bcgetbase:VTMK_DATA;
procedure bcputw( bcAddr, bcData : VTMK_DATA);
function bcgetw( bcAddr:VTMK_DATA ):VTMK_DATA;
function bcgetansw( bcCtrlCode : VTMK_DATA):DWORD;
procedure bcputblk( bcAddr:VTMK_DATA; var pcBuffer; cwLength:VTMK_DATA );
procedure bcgetblk( bcAddr:VTMK_DATA; var pcBuffer; cwLength:VTMK_DATA );
function bcdefbus( bcBus :VTMK_DATA):integer;
function bcgetbus:VTMK_DATA ;
function bcstart( bcBase, bcCtrlCode :VTMK_DATA ):integer;
function bcstartx( bcBase,bcCtrlCode :VTMK_DATA ):integer;
function bcdeflink( bcBase,bcCtrlCode :VTMK_DATA ):integer;
function bcgetlink:DWORD;
function bcstop:VTMK_DATA;
function bcgetstate:DWORD;


function rtreset:integer;
function rtdefirqmode( rtIrqMode :VTMK_DATA):integer;
function rtgetirqmode:VTMK_DATA;
function rtdefmode(rtMode :VTMK_DATA):integer;
function rtgetmode:VTMK_DATA;
function rtgetmaxpage:VTMK_DATA;
function rtdefpage( rtPage:VTMK_DATA ):integer;
function rtgetpage:VTMK_DATA;
function rtdefpagepc( rtPagePC :VTMK_DATA):integer;
function rtdefpagebus( rtPageBus : VTMK_DATA):integer;
function rtgetpagepc:VTMK_DATA;
function rtgetpagebus:VTMK_DATA;
function rtdefaddress( rtAddress : VTMK_DATA):integer;
function rtgetaddress:VTMK_DATA;
procedure rtdefsubaddr( rtDir, rtSubAddr : VTMK_DATA);
function rtgetsubaddr:VTMK_DATA;
procedure rtputw( rtAddr, rtData :VTMK_DATA);
function rtgetw( rtAddr:VTMK_DATA ):VTMK_DATA;
procedure rtputblk( rtAddr:VTMK_DATA;var pcBuffer; cwLength:VTMK_DATA );
procedure rtgetblk( rtAddr:VTMK_DATA;var pcBuffer; cwLength:VTMK_DATA );
procedure rtsetanswbits(rtSetControl:VTMK_DATA);
procedure rtclranswbits(rtClrControl:VTMK_DATA);
function rtgetanswbits:VTMK_DATA;
procedure rtgetflags( var pcBuffer; rtDir,rtFlagMin,rtFlagMax:VTMK_DATA );
procedure rtputflags( var pcBuffer; rtDir,rtFlagMin,rtFlagMax:VTMK_DATA );
procedure rtsetflag;
procedure rtclrflag;
function rtgetflag( rtDir, rtSubAddr :VTMK_DATA):VTMK_DATA;
function rtgetstate:VTMK_DATA;
function rtbusy:VTMK_DATA;
procedure rtlock( rtDir, rtSubAddr :VTMK_DATA);
procedure rtunlock;
function rtgetcmddata( rtBusCommand:VTMK_DATA ):VTMK_DATA;
procedure rtputcmddata( rtBusCommand, rtData :VTMK_DATA);

function mtreset:integer;

const
 mtdefirqmode:function( bcIrqMode : VTMK_DATA):integer = bcdefirqmode;
 mtgetirqmode:function:VTMK_DATA = bcgetirqmode;
 mtgetmaxbase:function:VTMK_DATA  = bcgetmaxbase;
 mtdefbase:function(bcBasePC:VTMK_DATA):integer  = bcdefbase;
 mtgetbase:function:VTMK_DATA  = bcgetbase;
 mtputw:procedure(bcAddr,bcData:VTMK_DATA) = bcputw;
 mtgetw:function(bcAddr:VTMK_DATA):VTMK_DATA = bcgetw;

 function mtgetsw:VTMK_DATA;

const
 mtputblk:procedure(bcAddr:VTMK_DATA;var pcBuffer;cwLength:VTMK_DATA) = bcputblk;
 mtgetblk:procedure(bcAddr:VTMK_DATA;var pcBuffer;cwLength:VTMK_DATA) = bcgetblk;
 mtstartx:function(bcBase,bcCtrlCode:VTMK_DATA):integer = bcstartx;
 mtdeflink:function(bcBase,bcCtrlCode:VTMK_DATA):integer = bcdeflink;
 mtgetlink:function:DWORD = bcgetlink;
 mtstop:function:VTMK_DATA = bcstop;
 mtgetstate:function:DWORD = bcgetstate;


{*****************Functions***************************}

Implementation

{ CONTROLLER functions }

function TmkOpen:DWORD;
var
 _awVTMK4InBuf,_awVTMK4OutBuf:word;
 _cbVTMK4Ret,dwErrorCode:DWORD;
 iTMK:integer;
 _hinstVTMK4Kernel32:HINST;
 p:integer;
begin

  _hVTMK4VxD := CreateFile('\\.\VTMK.VXD', 0,0,NIL, TRUNCATE_EXISTING, FILE_FLAG_DELETE_ON_CLOSE, 0);
  if ( _hVTMK4VxD = INVALID_HANDLE_VALUE ) then
  begin
    dwErrorCode := GetLastError();
    _hVTMK4VxD := 0;
    TmkOpen:=dwErrorCode;
    Exit;
  end;
  for iTMK := 0 to MAX_TMK_NUMBER do
    _ahVTMK4Event[iTMK] := 0;
  if (Not DeviceIoControl(_hVTMK4VxD, VTMK_GetVersion,@_awVTMK4InBuf, 0,@_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL)) OR
     ( _awVTMK4OutBuf < VTMK_VERSION_MIN) then
  begin
    CloseHandle(_hVTMK4VxD);
    _hVTMK4VxD := 0;
    TmkOpen := VTMK_BAD_VERSION;
    Exit;
  end;
  P:=Windows.GetModuleHandle('kernel32.dll');
  _hinstVTMK4Kernel32 := P;
  if (_hinstVTMK4Kernel32 = 0) then
  begin
    CloseHandle(_hVTMK4VxD);
    _hVTMK4VxD := 0;
    TmkOpen := TMK_BAD_FUNC;
    Exit;
  end;
  _VTMK4OpenVxDHandle := GetProcAddress(_hinstVTMK4Kernel32, 'OpenVxDHandle');
  TmkOpen:=0;
  Exit;
end;

procedure TmkClose;
begin
  if (_hVTMK4VxD<>0) then
  begin
    CloseHandle(_hVTMK4VxD);
    _hVTMK4VxD := 0;
  end
end;

function tmkgetmaxn:integer;
var
 _awVTMK4InBuf:word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkgetmaxn, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  tmkgetmaxn:=_awVTMK4OutBuf;
end;

function tmkconfig( tmkNumber:integer ):integer;
var
 _awVTMK4InBuf:word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;

begin
  _VTMK4tmkNumber := tmkNumber;
  _awVTMK4InBuf:=word(tmkNumber);
  if DeviceIoControl(_hVTMK4VxD, VTMK_tmkconfig, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
   then tmkconfig:=0
   else tmkconfig:=GetLastError;
end;

function tmkdone( tmkNumber:integer ):integer;
var
 _awVTMK4InBuf:word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
 iTMK:integer;
begin

  if (tmkNumber = ALL_TMKS) then
  begin
    for iTMK := 0 to MAX_TMK_NUMBER do
      _ahVTMK4Event[iTMK] := 0;
  end
  else if (tmkNumber >= 0) AND (tmkNumber <= MAX_TMK_NUMBER) then
    _ahVTMK4Event[tmkNumber] := 0;
  _awVTMK4InBuf:=WORD(tmkNumber);
  if DeviceIoControl(_hVTMK4VxD, VTMK_tmkdone, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
   then tmkdone:=0
   else tmkdone:=GetLastError;
end;

function tmkselect(tmkNumber:integer):integer;
var
 _awVTMK4InBuf:word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _VTMK4tmkNumber := tmkNumber;
  _awVTMK4InBuf:=WORD(tmkNumber);
  if DeviceIoControl(_hVTMK4VxD, VTMK_tmkselect, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
  then tmkselect:=0
  else tmkselect:=GetLastError;
end;

function tmkselected:integer;
var
 _awVTMK4InBuf:word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkselected, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  _VTMK4tmkNumber := _awVTMK4OutBuf;
  tmkselected:=_VTMK4tmkNumber;
end;

function tmkgetmode:VTMK_DATA;
var
 _awVTMK4InBuf:word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkgetmode, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  tmkgetmode:=_awVTMK4OutBuf;
end;

procedure tmksetcwbits(  tmkSetControl:VTMK_DATA );
var
 _awVTMK4InBuf:word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=tmkSetControl;
  DeviceIoControl(_hVTMK4VxD, VTMK_tmksetcwbits, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

procedure tmkclrcwbits( tmkClrControl:VTMK_DATA );
var
 _awVTMK4InBuf:word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=tmkClrControl;
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkclrcwbits, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

function tmkgetcwbits:VTMK_DATA;
var
 _awVTMK4InBuf:word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkgetcwbits, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  tmkgetcwbits:= _awVTMK4OutBuf;
end;

procedure tmkdefevent(hEvent:tHandle;fEventSet:boolean);
var
 _awVTMK4InBuf:array[0..3] of word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
 hVxDEvent:DWORD;
 iTMK:integer;
begin
  hVxDEvent := 0;
  if (hEvent <> 0) then
  begin
    for iTMK := 0 to MAX_TMK_NUMBER do
    begin
      if (hEvent = _ahVTMK4Event[iTMK]) then
        break;
      if (iTMK = MAX_TMK_NUMBER) then
      begin
       hVxDEvent := _VTMK4OpenVxDHandle(hEvent);
       _ahVTMK4Event[_VTMK4tmkNumber] := hEvent;
      end;
    end;
  end
  else _ahVTMK4Event[_VTMK4tmkNumber] := 0;

  _awVTMK4InBuf[0]:=LOWORD(hVxDEvent);
  _awVTMK4InBuf[1]:=HIWORD(hVxDEvent);
  _awVTMK4InBuf[2]:=byte(fEventSet);
  _awVTMK4InBuf[3]:=0;
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkdefevent, @_awVTMK4InBuf, 8, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

procedure tmkgetevd( pEvD:PTmkEventData );
type
 pInteger=^integer;
var
 _awVTMK4InBuf:word;
 _awVTMK4OutBuf:array[0..5] of word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkgetevd, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 12, _cbVTMK4Ret, NIL);
  pEvD^.nInt := pInteger(@_awVTMK4OutBuf[0])^;
  pEvD^.wMode := _awVTMK4OutBuf[2];

  case pEvD^.wMode of

  BC_MODE:
    case pEvD^.nInt of
     1:  pEvD^.wResult := _awVTMK4OutBuf[3];
     2: begin
         pEvD^.wResult := _awVTMK4OutBuf[3];
         pEvD^.wAW1    := _awVTMK4OutBuf[4];
         pEvD^.wAW2    := _awVTMK4OutBuf[5];
        end;
     3: begin
         pEvD^.wResultX := _awVTMK4OutBuf[3];
         pEvD^.wBase    := _awVTMK4OutBuf[4];
        end;
     4:  pEvD^.wBase := _awVTMK4OutBuf[3];
    end;
  MT_MODE:
    case pEvD^.nInt of
     3: begin
         pEvD^.wResultX := _awVTMK4OutBuf[3];
         pEvD^.wBase    := _awVTMK4OutBuf[4];
        end;
     4:  pEvD^.wBase := _awVTMK4OutBuf[3];
    end;
  RT_MODE:
    case pEvD^.nInt of
     1:  pEvD^.wCmd    := _awVTMK4OutBuf[3];
     2,3:pEvD^.wStatus := _awVTMK4OutBuf[3];
    end;
  end;
end;

procedure tmkgetinfo(pConfD:PTmkConfigData);
var
 _awVTMK4InBuf:pointer;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=pConfD;
  DeviceIoControl(_hVTMK4VxD, VTMK_tmkgetinfo, @_awVTMK4InBuf, 4, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

function bcreset:integer;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  if DeviceIoControl(_hVTMK4VxD, VTMK_bcreset, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
  then bcreset:=0
  else bcreset:=GetLastError;
end;

procedure bc_def_tldw( wTLDW :VTMK_DATA );
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=wTLDW;
  DeviceIoControl(_hVTMK4VxD, VTMK_bc_def_tldw, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

procedure bc_enable_di;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_bc_enable_di, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

procedure bc_disable_di;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_bc_disable_di, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

function bcdefirqmode( bcIrqMode : VTMK_DATA ):integer;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=bcIrqMode;
  if DeviceIoControl(_hVTMK4VxD, VTMK_bcdefirqmode, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;

function bcgetirqmode:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetirqmode, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

function bcgetmaxbase:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetmaxbase, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

function bcdefbase( bcBasePC : VTMK_DATA ):integer;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=bcBasePC;
  if DeviceIoControl(_hVTMK4VxD, VTMK_bcdefbase, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;
function bcgetbase:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetbase, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;
procedure bcputw( bcAddr, bcData : VTMK_DATA);
var
 _awVTMK4InBuf: array[0..1] of word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf[0]:=bcAddr;
  _awVTMK4InBuf[1]:=bcData;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcputw, @_awVTMK4InBuf, 4, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

function bcgetw(  bcAddr : VTMK_DATA):VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=bcAddr;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetw, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

function bcgetansw(  bcCtrlCode : VTMK_DATA):DWORD;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:PDWORD;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=bcCtrlCode;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetansw, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 4, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf^;
end;
procedure bcputblk(bcAddr:VTMK_DATA;var pcBuffer; cwLength:VTMK_DATA );
var
 _awVTMK4InBuf:packed record
                       BA:word;
                       Buf:pointer;
                       Len:word;
                      end;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf.BA:=bcAddr;
  _awVTMK4InBuf.Buf:=ADDR(pcBuffer);
  _awVTMK4InBuf.Len:=cwLength;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcputblk, @_awVTMK4InBuf, 8, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;
procedure bcgetblk(bcAddr:VTMK_DATA;var pcBuffer; cwLength:VTMK_DATA );
var
 _awVTMK4InBuf:packed record
                       BA:word;
                       Buf:pointer;
                       Len:word;
                      end;

 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf.BA:=bcAddr;
  _awVTMK4InBuf.Buf:=ADDR(pcBuffer);
  _awVTMK4InBuf.Len:=cwLength;
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetblk, @_awVTMK4InBuf, 8, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

function bcdefbus(  bcBus:VTMK_DATA ):integer;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=bcBus;
  if DeviceIoControl(_hVTMK4VxD, VTMK_bcdefbus, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;
function bcgetbus:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetbus, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

function bcstart( bcBase, bcCtrlCode:VTMK_DATA ):integer;
var
 _awVTMK4InBuf: array[0..1] of word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf[0]:=bcBase;
  _awVTMK4InBuf[1]:=bcCtrlCode;
  if DeviceIoControl(_hVTMK4VxD, VTMK_bcstart, @_awVTMK4InBuf, 4, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;
function bcstartx( bcBase, bcCtrlCode:VTMK_DATA ):integer;
var
 _awVTMK4InBuf: array[0..1] of word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf[0]:=bcBase;
  _awVTMK4InBuf[1]:=bcCtrlCode;
  if DeviceIoControl(_hVTMK4VxD, VTMK_bcstartx, @_awVTMK4InBuf, 4, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;
function bcdeflink( bcBase, bcCtrlCode:VTMK_DATA ):integer;
var
 _awVTMK4InBuf: array[0..1] of word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf[0]:=bcBase;
  _awVTMK4InBuf[1]:=bcCtrlCode;
  if DeviceIoControl(_hVTMK4VxD, VTMK_bcdeflink, @_awVTMK4InBuf, 4, @_awVTMK4OutBuf, 0,_cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;

function bcgetlink:DWORD;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:^DWORD;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetlink, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 4, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf^;
end;

function bcstop:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_bcstop, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;
function bcgetstate:DWORD;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:^DWORD;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_bcgetstate, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 4, _cbVTMK4Ret, NIL);
  result:=_awVTMK4OutBuf^;
end;

{ TERMINAL functions }

function rtreset:integer;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  if DeviceIoControl(_hVTMK4VxD, VTMK_rtreset, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;

function rtdefirqmode(  rtIrqMode :VTMK_DATA):integer;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=rtIrqMode;
  if DeviceIoControl(_hVTMK4VxD, VTMK_rtdefirqmode, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0,_cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;

function rtgetirqmode:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetirqmode,@_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

function rtdefmode( rtMode : VTMK_DATA):integer;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=rtMode;
  if DeviceIoControl(_hVTMK4VxD, VTMK_rtdefmode, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;

function rtgetmode:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetmode, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

function rtgetmaxpage:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetmaxpage, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

function rtdefpage(  rtPage : VTMK_DATA):integer;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=rtPage;
  if DeviceIoControl(_hVTMK4VxD, VTMK_rtdefpage, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0,_cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;

function rtgetpage:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetpage, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

function rtdefpagepc(  rtPagePC :VTMK_DATA):integer;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=rtPagePC;
  if DeviceIoControl(_hVTMK4VxD, VTMK_rtdefpagepc, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;

function rtdefpagebus(  rtPageBus :VTMK_DATA):integer;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=rtPageBus;
  if DeviceIoControl(_hVTMK4VxD, VTMK_rtdefpagebus, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0,_cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;

function rtgetpagepc:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetpagepc, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

function rtgetpagebus:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetpagebus, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

function rtdefaddress(  rtAddress :VTMK_DATA):integer;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=rtAddress;
  if DeviceIoControl(_hVTMK4VxD, VTMK_rtdefaddress, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;

function rtgetaddress:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetaddress, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

procedure rtdefsubaddr( rtDir, rtSubAddr : VTMK_DATA);
var
 _awVTMK4InBuf: array[0..1] of word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf[0]:=rtDir;
  _awVTMK4InBuf[1]:=rtSubAddr;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtdefsubaddr, @_awVTMK4InBuf, 4, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

function rtgetsubaddr:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetsubaddr, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result :=_awVTMK4OutBuf;
end;

procedure rtputw( rtAddr, rtData : VTMK_DATA);
var
 _awVTMK4InBuf: array[0..1] of word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf[0]:=rtAddr;
  _awVTMK4InBuf[1]:=rtData;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtputw, @_awVTMK4InBuf, 4, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

function rtgetw( rtAddr:VTMK_DATA ):VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=rtAddr;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetw, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

procedure rtputblk( rtAddr:VTMK_DATA;var pcBuffer;cwLength:VTMK_DATA);
var
 _awVTMK4InBuf:packed record
                       BA:word;
                       Buf:pointer;
                       Len:word;
                      end;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf.BA:=rtAddr;
  _awVTMK4InBuf.Buf:=ADDR(pcBuffer);
  _awVTMK4InBuf.Len:=cwLength;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtputblk, @_awVTMK4InBuf, 8, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

procedure rtgetblk( rtAddr:VTMK_DATA;var pcBuffer;cwLength:VTMK_DATA);
var
 _awVTMK4InBuf:packed record
                       BA:word;
                       Buf:pointer;
                       Len:word;
                      end;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf.BA:=rtAddr;
  _awVTMK4InBuf.Buf:=ADDR(pcBuffer);
  _awVTMK4InBuf.Len:=cwLength;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetblk, @_awVTMK4InBuf, 8, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

procedure rtsetanswbits(  rtSetControl:VTMK_DATA );
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=rtSetControl;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtsetanswbits, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

procedure rtclranswbits( rtClrControl:VTMK_DATA );
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=rtClrControl;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtclranswbits, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

function rtgetanswbits:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetanswbits, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

procedure rtgetflags( var pcBuffer; rtDir, rtFlagMin, rtFlagMax:VTMK_DATA );
var
 _awVTMK4InBuf: packed record
                  Buf:pointer;
                  Dir:word;
                  FMin:word;
                  FMax:word;
                end;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf.Buf:=ADDR(pcBuffer);
  _awVTMK4InBuf.Dir:=rtDir;
  _awVTMK4InBuf.FMin:=rtFlagMin;
  _awVTMK4InBuf.FMax:=rtFlagMax;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetflags, @_awVTMK4InBuf, 10, @_awVTMK4OutBuf, 0,_cbVTMK4Ret, NIL);
end;

procedure rtputflags( var pcBuffer; rtDir, rtFlagMin, rtFlagMax:VTMK_DATA );
var
 _awVTMK4InBuf: packed record
                  Buf:pointer;
                  Dir:word;
                  FMin:word;
                  FMax:word;
                end;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf.Buf:=ADDR(pcBuffer);
  _awVTMK4InBuf.Dir:=rtDir;
  _awVTMK4InBuf.FMin:=rtFlagMin;
  _awVTMK4InBuf.FMax:=rtFlagMax;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtputflags, @_awVTMK4InBuf, 10, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

procedure rtsetflag;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtsetflag, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

procedure rtclrflag;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtclrflag, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

function rtgetflag(rtDir,rtSubAddr:VTMK_DATA):VTMK_DATA;
var
 _awVTMK4InBuf: array[0..1] of word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf[0]:=rtDir;
  _awVTMK4InBuf[1]:=rtSubAddr;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetflag, @_awVTMK4InBuf, 4, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

function rtgetstate:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetstate, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

function rtbusy:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtbusy, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

procedure rtlock(rtDir,rtSubAddr:VTMK_DATA);
var
 _awVTMK4InBuf:array[0..1] of word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf[0]:=rtDir;
  _awVTMK4InBuf[1]:=rtSubAddr;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtlock, @_awVTMK4InBuf, 4, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

procedure rtunlock;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_rtunlock, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

function rtgetcmddata( rtBusCommand : VTMK_DATA):VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf:=rtBusCommand;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtgetcmddata, @_awVTMK4InBuf, 2, @_awVTMK4OutBuf, 2, _cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

procedure rtputcmddata(rtBusCommand, rtData : VTMK_DATA);
var
 _awVTMK4InBuf: array[0..1] of word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  _awVTMK4InBuf[0]:=rtBusCommand;
  _awVTMK4InBuf[1]:=rtData;
  DeviceIoControl(_hVTMK4VxD, VTMK_rtputcmddata, @_awVTMK4InBuf, 4, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL);
end;

{ MONITOR functions }

function mtreset:integer;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  if DeviceIoControl(_hVTMK4VxD, VTMK_mtreset, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 0, _cbVTMK4Ret, NIL)
  then result:=0
  else result:=GetLastError;
end;

function mtgetsw:VTMK_DATA;
var
 _awVTMK4InBuf: word;
 _awVTMK4OutBuf:word;
 _cbVTMK4Ret:DWORD;
begin
  DeviceIoControl(_hVTMK4VxD, VTMK_mtgetsw, @_awVTMK4InBuf, 0, @_awVTMK4OutBuf, 2,_cbVTMK4Ret, NIL);
  result:= _awVTMK4OutBuf;
end;

end.
